<?php
/*
DKret2 helper functions
*/

function exist_active_widgets() {
  if (!function_exists('wp_get_sidebars_widgets')) return false;
  $sidebarswidgets = wp_get_sidebars_widgets();
  foreach ($sidebarswidgets as $sidebar) 
    if (!empty($sidebar)) return true;
  return false;
  
}

function exist_double_colon() {
  $sidebars = wp_get_sidebars_widgets();
  if (($sidebars['sidebar-2'] == '') || ($sidebars['sidebar-3'] == '')) return false;
  return true; 
}

function exist_footer_colon() {
  if (!function_exists('wp_get_sidebars_widgets')) return false;
  $sidebars = wp_get_sidebars_widgets();
  if (($sidebars['sidebar-5'] != '') || ($sidebars['sidebar-6'] != '') || ($sidebars['sidebar-7'] != '')) return true;
  return false; 
}

function dkret_version_check() {
	// check for a new version
	$check_intervall = get_option('dkret_next_update');
			
	if ( ($check_intervall < time() ) or (empty($check_intervall)) ) {
		if (class_exists(snoopy)) {
			$client = new Snoopy();
			$client->_fp_timeout = 10;
			if (@$client->fetch(DKRETURL) === false) {
				return false;
			}
			
		   	$remote = $client->results;
		   	
			$server_version = unserialize($remote);
			if (is_array($server_version)) {
				if ( version_compare($server_version[0], DKRETVERSION, '>') )
				 	return true;
			} 
			// come back in 24 hours :-)
			$check_intervall = time() + 86400;
			update_option('dkret_next_update', $check_intervall );
			return false;
		}				
	}
}

// Dashboard update notification
function dkret_update_dashboard() {
  echo '<h3>'. __('DKret2 Updates', 'dkret') .' <a href="http://diekretzschmars.de/dkret-theme/">&raquo;</a></h3>';
  if (dkret_version_check()) {
    _e('<p>Your version of dKret2 is outdated. Visit the dKret2 page for more informations.</p>', 'dkret');
  } else {
    _e('<p>No Updates available.</p>','dkret');
  }
}
add_action('activity_box_end', 'dkret_update_dashboard', '0');

function dkret_DisplaySubMenu( $args = '' )
{

/*
Plugin Name: Display SubMenue
Plugin URI: http://arno-simon.de/wordpress/navigation-haupt-subebene/
Description: Displays all static Pages associated to one TopLevel-Page
Version: 1.3
Author: Arno Simon
Author URI: http://arno-simon.de/
*/

 // extract the parameters out of $args
 parse_str($args, $do);
 // check if all params are givven
 if(!isset($do[title]))          $do[title]          = '';
 if(!isset($do[text_before]))    $do[text_before]    = '';
 if(!isset($do[text_after]))     $do[text_after]     = ''; 
 if(!isset($do[text4pagetitle])) $do[text4pagetitle] = '';
 if(!isset($do[useDivisor]))     $do[useDivisor]     = '';
 if(!isset($do[divisor]))        $do[divisor]        = 0;
 if(!isset($do[html_before]))    $do[html_before]    = '<h2>';
 if(!isset($do[html_after]))     $do[html_after]     = '</h2>';
 if(!isset($do[sort_column]))    $do[sort_column]    = 'menu_order';
 // get the parameters as regular vars
 foreach($do as $key => $value)
 { 
  $$key = $value;
 }
 if(!(    is_category() || is_day()
       || is_month()    || is_year()
       || is_search()
       || (     isset($_GET['paged'])
            && !empty($_GET['paged'])
          )
       || isset($_GET['s'])
     )
   ) 
  {
  global $wpdb;
  global $wp_query;
  $local_act_object = $wp_query->get_queried_object();
  $local_act_pageid = $local_act_object->ID;
  $local_prv_page_found = 'Z';
  while($local_prv_page_found != 'X') {
   $local_prv_pageid = $wpdb->get_var("SELECT post_parent "
         ."FROM $wpdb->posts WHERE ID = '$local_act_pageid'");
   if(    isset($local_prv_pageid)
       && $local_prv_pageid != null
       && $local_prv_pageid != 0) {
    $local_prv_parent = $wpdb->get_var("SELECT post_parent "
         ."FROM $wpdb->posts WHERE ID = '$local_prv_pageid'");
    if(isset($local_prv_parent) && $local_prv_parent != null) {
     if($local_prv_parent == 0) {
      $local_act_pageid = $local_prv_pageid;
      $local_prv_page_found = 'X';
     } else {
      $local_act_pageid = $local_prv_parent;
     }
    } elseif( $local_prv_parent == null ) {
     $local_act_pageid = $local_prv_pageid;
     $local_prv_page_found = 'X';
    }
   } else {
    $local_prv_page_found = 'X';
   }
  }
  if(isset($local_act_pageid) && !empty($local_act_pageid)) {
  $local_pageid = $local_act_pageid;
  $local_title = $wpdb->get_var("SELECT post_title FROM "
             ."$wpdb->posts WHERE ID = '$local_pageid'");
  $local_subpages = $wpdb->query("SELECT ID FROM "
        ."$wpdb->posts WHERE post_parent = '$local_pageid'");
  if($text4pagetitle != '') 
   $local_mentitle = $title.$text_before.$text4pagetitle.$text_after;
  else
   $local_mentitle = $title.$text_before.$local_title.$text_after;
  if($useDivisor != '' && $divisor > 0)
  {
   $lines = round(strlen($local_mentitle) / $divisor);
  }
  if(isset($local_subpages)) {
   if(!empty($local_subpages) || $local_subpages>0) {
    if($useDivisor != '')
    {
     ob_start();
     wp_list_pages('sort_column='.$sort_column.'&title_li='.$html_before
      .$local_mentitle.$html_after.'&depth=0&child_of='.$local_pageid);
     $page_list = ob_get_contents();
     ob_end_clean();
     if($lines > 1)
     {
      $page_list = str_replace('pagenav', 'pagenav'.$lines, $page_list);
     }
     echo $page_list;
    }
    else
    wp_list_pages('sort_column='.$sort_column.'&title_li='.$html_before
    .$local_mentitle.$html_after.'&depth=0&child_of='.$local_pageid);
   }
  }
  }
 } 
}

function dKretPaging() {

/*
Original Plugin Name: Yet Another Advanced Paged Navigation
Plugin URI: http://dreamincolours.com/projects/wordpress-plugins/yaapn/
Description: Heavily customizable paged navigation, localized by J.Kretzschmar for dKret2
Version: 1.05
Author: Monika "YaaL" Szczygieł
Author URI: http://dreamincolours.com
*/

global $request, $posts_per_page, $wpdb, $paged, $max_num_pages, $wp_query;

$template='<div class="paging"><h4>'.__('Page','dkret').' %CURRENT% '.__('of','dkret').' %COUNT%</h4> <ul>%FIRST% %PREV*% %SKIPB% %NUMBERED% %SKIPA% %NEXT*% %LAST%</ul></div>'; 
$template_item='<li>%ITEM%</li>';
$count=2;
$prevlabel=__('&lsaquo; Previous','dkret'); 
$currentlabel='<b>%NUMBER%</b>';
$nextlabel=__('Next &rsaquo;','dkret');
$firstlabel=__('Start','dkret'); 
$numberedlabel='%NUMBER%';
$lastlabel=__('End','dkret'); 
$skipped='<li> ... </li>';
$separator='';  

	if (!is_single()):
    $max_page=999999;
		if (get_query_var('what_to_show') == 'posts'):
			preg_match('#FROM\s(.*)\sGROUP BY#siU', $request, $matches);
			$fromwhere = $matches[1];
			$numposts = $wpdb->get_var("SELECT COUNT(DISTINCT ID) FROM $fromwhere");
			$max_page = ceil($numposts /$posts_per_page);
		elseif ( isset($max_num_pages) ):
			$max_page = $max_num_pages;
		else:
			$max_page = ceil($wp_query->max_num_pages);
		endif;
		
		if (empty($paged))
			$paged = 1;

		if ($count==0 || $count>$max_page)
			$count = $max_page;
		
		$skipb = $skipa = '';
		$prevlink	= (($paged<=1) ? '' : '<li><a href="'.get_pagenum_link($paged-1).'">'.$prevlabel.'</a></li>');
		$prevnotfirstlink = (($paged<=2) ? '' : '<li><a href="'.get_pagenum_link($paged-1).'">'.$prevlabel.'</a></li>');
		$nextlink = (($paged==$max_page) ? '' : '<li><a href="'.get_pagenum_link($paged+1).'">'.$nextlabel.'</a></li>');
		$nextnotlastlink = (($paged>=$max_page-1) ? '' : '<li><a href="'.get_pagenum_link($paged+1).'">'.$nextlabel.'</a></li>');
		$firstlink = (($paged<=1) ? '' : '<li><a href="'.get_pagenum_link().'">'. $firstlabel.'</a></li>');
		$lastlink = (($paged==$max_page)? '' : '<li><a href="'.get_pagenum_link($max_page).'">'.$lastlabel.'</a></li>');
		
    $currentlabel = str_replace('%NUMBER%', $paged, $currentlabel);

		$result = '';
		if ($max_page > 1):
			if ( ($paged -$count) > 1)
				$skipb = $skipped;

			$numbered='';
   		for($i = ($paged - $count); $i <= ($paged + $count); $i++):
	  		if ( $i >= 1 && $i <= $max_page):
//		  		$numbered .= str_replace('%NUMBER%', $i, $beforelink). (($i == $paged) ? $currentlabel : '<a href="'.get_pagenum_link($i).'">'. str_replace('%NUMBER%', $i, $numberedlabel) .'</a>' ) . str_replace('%NUMBER%', $i, $afterlink);
					$label = (($i == $paged) ? $currentlabel : '<a href="'.get_pagenum_link($i).'">'. str_replace('%NUMBER%', $i, $numberedlabel) .'</a>' );
		  		$numbered .= str_replace(array('%ITEM%', '%NUMBER%'), array($label, $i), $template_item);
			  endif;
				
 				if ($i >= 1 && $i < min($paged+$count, $max_page)):
  				$numbered .= $separator;
	  		endif;
		  endfor;

			if (($paged + $count) < $max_page)
				$skipa = $skipped;
			
			$result = str_replace(
				array('%COUNT%', '%CURRENT%', '%PREV%', '%PREV*%', '%NEXT%', '%NEXT*%', '%FIRST%', '%LAST%', '%NUMBERED%', '%SKIPB%', '%SKIPA%'),
				array($max_page, $paged, $prevlink, $prevnotfirstlink, $nextlink, $nextnotlastlink, $firstlink, $lastlink, $numbered, $skipb, $skipa),
				$template);
			echo $result;
		endif;

	endif;
}

//add css for dKret2 options panel
function dkret2_adminstyle() {
  echo '
  <style type="text/css">
  h3 {
  	font: normal 1.8em Georgia;
  	margin: 30px 0 0;
  	color: #222;
  }
  
  small {
  	color: #666;
  }
  
  .configstuff {
  	width: 700px;
  	margin: 0 auto;
  	font-size: 1.1em;
  }
  </style>';
}

function findrandompicture() {
/* 
Original Plugin Name: K2-Picture upload
Original Plugin URI: http://ramlev.dk/wp-plugins/
Description: Change header picture.
Author: Hasse Ramlev Hansen <hasse@ramlev.dk>
Author URI: http://ramlev.dk
Version: 1.1.1
*/

	$picture_dir = @ dir(ABSPATH . '/wp-content/themes/' . get_template() . '/images/headers');
	if ($picture_dir)
	{
		while(($file = $picture_dir->read()) !== false)
		{
			if (!preg_match('|^\.+$|', $file) && !preg_match('|^CVS$|', $file))
			{
				$picture_files[] = $file;
			}
		}
	}
  $size = count($picture_files);
  return ($picture_files[rand(0, $size-1)]);
}

function change_hpicture() {
	if (get_option('dkret_imagerandomfeature') == "1")
	{
		$picture = findrandompicture();
	}
	else
	{
		$picture = get_option('dkret_header_picture');
	}	

	if ($picture != "dKret2")
	{
	echo '
		<style>
			#header
			{
				background: url('.get_bloginfo('wpurl').'/wp-content/themes/dkret2/images/headers/'.$picture.') repeat-x;
			}
		</style>
	';
	}
}

add_action('admin_head', 'dkret2_adminstyle');
add_action('wp_head','change_hpicture');

?>
