<?php
/*
Plugin Name: dKret Search widget
Description: Adds a sidebar widget to search site.
Author: J. Kretzschmar
Version: 1.1
Author URI: http://diekretzschmars.de
*/

function widget_dkret_search($args) {
	extract($args);
	$options = get_option('widget_dkret_search'); ?>
  <div id="Suche">
      <h2 class="widget_title"><?php echo ($options['title']) ?></h2>
     	<form method="get" id="searchform" action="<?php echo htmlspecialchars($_SERVER['PHP_SELF']); ?>">
    		<input type="text" value="<?php echo wp_specialchars($s, 1); ?>" name="s" id="s" />
    	</form>
  </div>
<?php }

// Admin section
function widget_control_dkret_search() {
 	global $wpdb;
 	$options = get_option('widget_dkret_search');
    		
	if ( $_POST['dkret-submit'] ) {

		$options['title'] = strip_tags(stripslashes($_POST['dkret-search-title']));
		update_option('widget_dkret_search', $options);
	}
	
	$title = htmlspecialchars($options['title'], ENT_QUOTES);
	
	// The Box content
	echo '<p style="text-align:right;"><label for="dkret-search-title" />' . __('Title:', 'dkret') . ' <input style="width: 200px;" id="dkret-search-title" name="dkret-search-title" type="text" value="'.$title.'" /></p>';
	echo '<input type="hidden" id="dkret-submit" name="dkret-submit" value="1" />';
}

$options = get_option('widget_dkret_search');
if ( !is_array($options) )
	$options = array('title'=>''. __('Search', 'dkret') .'',);
	update_option('widget_dkret_search', $options);

register_sidebar_widget(__('dKret: Search','dkret'), 'widget_dkret_search');
register_widget_control(__('dKret: Search','dkret'), 'widget_control_dkret_search', 300, 200);
?>
